package org.example;

public class CustomDate {
    private int day;
    private int month;
    private int year;

    public CustomDate(int day, int month, int year) {
        this.day = day;
        this.month = month;
        this.year = year;
    }

    public int getDay() {
        return day;
    }

    public int getMonth() {
        return month;
    }

    public int getYear() {
        return year;
    }

    public String toString() {
        return String.format("%d.%d.%d", day, month, year);
    }

    public static CustomDate random(int aroundYear, int yearRange) {
        int year = (int) (Math.random() * yearRange) + aroundYear - yearRange / 2;
        int month = (int) (Math.random() * 12) + 1;
        int day = (int) (Math.random() * 28) + 1;

        return new CustomDate(day, month, year);
    }

    public static CustomDate fromString(String date) {
        String[] parts = date.split("\\.");
        if(parts.length != 3) {
            return null;
        }

        int day = Integer.parseInt(parts[0]);
        int month = Integer.parseInt(parts[1]);
        int year = Integer.parseInt(parts[2]);

        return new CustomDate(day, month, year);
    }
}
