package org.example;

import java.util.ArrayList;

public class FilteredInvoices {
    private final ArrayList<FilteredInvoice> invoices = new ArrayList<>();

    public FilteredInvoices() {
    }

    private static boolean applyFilter(Car car, String filterBy, int rangeFrom, int rangeTo) {
        return switch (filterBy) {
            case "none" -> true;
            case "year" -> {
                int year = car.getYear();
                yield year >= rangeFrom && year <= rangeTo;
            }
            case "price" -> {
                int price = (int) car.price;
                yield price >= rangeFrom && price <= rangeTo;
            }
            default -> false;
        };
    }

    public FilteredInvoice addInvoice(String filterBy, int rangeFrom, int rangeTo) {
        ArrayList<Car> cars = Main.getCars();
        ArrayList<Car> filteredCars = new ArrayList<>();

        for(Car car : cars) {
            if(!applyFilter(car, filterBy, rangeFrom, rangeTo)) continue;
            filteredCars.add(car);
        }

        FilteredInvoice invoice = new FilteredInvoice(filteredCars);
        invoice.addInfo(filterBy, rangeFrom, rangeTo);
        invoice.generate();
        invoices.add(invoice);
        return invoice;
    }

    public ArrayList<FilteredInvoice> getInvoices() {
        return this.invoices;
    }
}
