package org.example;

import org.imgscalr.Scalr;
import spark.Request;
import spark.Response;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;

public class Helper {
    public static String getAsset(String directory, String fileName, Response res) {
        String path = directory + "/" + fileName;

        res.type("application/octet-stream");
        res.header("Content-Disposition", "attachment; filename=" + fileName);

        try {
            OutputStream outputStream = res.raw().getOutputStream();
            outputStream.write(Files.readAllBytes(Path.of(path)));
        } catch (Exception e) {
            return "{\"error\": \"Photo not found\"}";
        }

        return "";
    }

    public static void applyPhotoEffect(String filePath, String effectName, ArrayList<Integer> params) throws IOException {
        File sourceFile = new File(filePath);
        BufferedImage originalImage = ImageIO.read(sourceFile);
        BufferedImage targetImage;
        System.out.println(effectName + params.toString() + filePath);

        switch (effectName) {
            case "rotate" -> {
                targetImage = Scalr.rotate(originalImage, Scalr.Rotation.CW_90);
                break;
            }
            case "flipV" -> {
                targetImage = Scalr.rotate(originalImage, Scalr.Rotation.FLIP_VERT);
                break;
            }
            case "flipH" -> {
                targetImage = Scalr.rotate(originalImage, Scalr.Rotation.FLIP_HORZ);
                break;
            }
            case "crop" -> {
                int x = params.get(0);
                int y = params.get(1);
                int width = params.get(2);
                int height = params.get(3);
                targetImage = Scalr.crop(originalImage, x, y, width, height);
                break;
            }
            default -> {
                System.out.println("No effect selected");
                targetImage = originalImage;
                break;
            }
        }

        ImageIO.write(targetImage, "jpg", sourceFile);
    }
}
