const contentDiv = document.getElementById('galleryContent');
const uploadContentDiv = document.getElementById('uploadContent');
const saveButton = document.getElementById('saveButton');

const filesToUpload = [];
const uuid = window.location.search.split('uuid=')[1].split('&')[0];

async function loadData() {
    let url = 'gallery/' + uuid;
    data = await fetchAPI(url, null, 'GET');

    if(!Array.isArray(data)) return;
    let html = '';
    for(let i = 0; i < data.length; i++) {
        const url = apiUrl + data[i];
        const filename = data[i].split('/').at(-1);
        html += `<div class="galleryPhoto">
            <img src="${url}" alt="zdjęcie">
            <div class="editPhoto" onclick="goToPage('/imager.html?name=${filename}')">Edytuj</div>
        </div>`;
    }

    contentDiv.innerHTML = html;
}

function updateUploadDiv() {
    if(!filesToUpload.length) {
        uploadContentDiv.innerHTML = '<div class="uploadTip">Przeciągnij pliki tutaj</div>';
        saveButton.disabled = true;
        return;
    }

    let html = '';
    for(let i = 0; i < filesToUpload.length; i++) {
        const url = apiUrl + filesToUpload[i];
        html += `<div class="uploadPhoto">
            <img src="${url}" alt="zdjęcie">
            <div class="removeUploadPhoto" onclick="removeUploadPhoto('${filesToUpload[i]}')">X</div>
        </div>`;
    }

    uploadContentDiv.innerHTML = html;
    saveButton.disabled = false;
}

function removeUploadPhoto(path) {
    const index = filesToUpload.indexOf(path);
    if(index < 0) return;
    filesToUpload.splice(index, 1);
    updateUploadDiv();
}

uploadContentDiv.addEventListener('dragover', (e) => {
    e.preventDefault();
});

uploadContentDiv.addEventListener('drop', async (e) => {
    e.preventDefault();
    let files = e.dataTransfer.files;
    let res = await uploadFiles('gallery', files, 'POST', false);
    if(!Array.isArray(res)) return;
    filesToUpload.push(...res);
    updateUploadDiv();
});

saveButton.addEventListener('click', async (e) => {
    e.preventDefault();

    const obj = {
        uuid: uuid,
        paths: filesToUpload
    }

    let res = await fetchAPI('gallerySave', obj, 'POST');
    if(!res) return;
    filesToUpload.length = 0;
    updateUploadDiv();
    loadData();
});

updateUploadDiv();
loadData();