const apiUrl = 'http://localhost:8080/';

async function fetchAPI(path, body, method, showAlert = false) {
    const req = {
        method: method,
        headers: {
            'Content-Type': 'application/json'
        }
    };
    if(body) req.body = JSON.stringify(body);

    let res = await fetch(apiUrl + path, req)
    .catch(err => alert('Network error: ' + err.message));

    let obj = await res.json();

    if(showAlert) {
        let json = JSON.stringify(obj, null, 2);
        alert(json);
    }

    return obj;
}

async function uploadFiles(path, files, method, showAlert = false) {
    if(!files?.length) return;
    let formData = new FormData();
    for (let i = 0; i < files.length; i++) {
        formData.append('file', files[i]);
    }

    const req = {
        method: method,
        body: formData,
    };

    let res = await fetch(apiUrl + path, req)
    .catch(err => alert('Network error: ' + err.message));

    let obj = await res.json();

    if(showAlert) {
        let json = JSON.stringify(obj, null, 2);
        alert(json);
    }

    return obj;
}

function downloadInvoice(name) {
    window.open(apiUrl + 'invoices/'+name, "_blank");
}

function goToPage(url) {
    window.open(url, "_self");
}