const addCarForm = document.getElementById('addCarForm');
const addRandomForm = document.getElementById('addRandomForm');

function getAirbag(element, description) {
    return {
        description: description,
        value: element.checked
    }
}

addCarForm.addEventListener('submit', async (e) => {
    e.preventDefault();

    const car = {
        model: addCarForm.carModel.value,
        year: addCarForm.carYear.value,
        color: addCarForm.carColor.value,
        airbags: [
            getAirbag(addCarForm.carAirbagA, 'driver'),
            getAirbag(addCarForm.carAirbagB, 'passenger'),
            getAirbag(addCarForm.carAirbagC, 'rear'),
            getAirbag(addCarForm.carAirbagD, 'rearSide')
        ],
        price: addCarForm.carPrice.value,
        vat: addCarForm.carVAT.value,
    };

    let res = await fetch('http://localhost:8080/add', {
        method: 'POST',
        body: JSON.stringify(car),
        headers: {
            'Content-Type': 'application/json'
        }
    })
    .catch(err => alert('Network error: ' + err.message));

    let obj = await res.json();
    let json = JSON.stringify(obj, null, 2);
    alert(json);
});

addRandomForm.addEventListener('submit', async (e) => {
    e.preventDefault();

    let res = await fetch('http://localhost:8080/generate', {
        method: 'POST',
        body: JSON.stringify({count: e.target.carCount.value}),
        headers: {
            'Content-Type': 'application/json'
        }
    })
    .catch(err => alert('Network error: ' + err.message));

    let obj = await res.json();
    let json = JSON.stringify(obj, null, 2);
    alert(json);
});