const hideIfFilterNone = Array.from(document.getElementsByClassName('hideIfFilterNone'));
const addInvoiceForm = document.getElementById('addInvoiceForm');
const contentDiv = document.getElementById('content');
let data;

function updateFilterOptionsVisibility() {
    let filterBy = addInvoiceForm['invFilterBy'].value;
    let display = filterBy === 'none' ? 'none' : '';
    hideIfFilterNone.forEach(element => {
        element.style.display = display;
    });
}

addInvoiceForm['invFilterBy'].addEventListener('change', updateFilterOptionsVisibility);
updateFilterOptionsVisibility();

addInvoiceForm.addEventListener('submit', async (e) => {
    e.preventDefault();

    const invoice = {
        filterBy: addInvoiceForm['invFilterBy'].value || 'none',
        rangeFrom: addInvoiceForm['invRangeFrom'].value || "0", 
        rangeTo: addInvoiceForm['invRangeTo'].value || "0"
    };

    await fetchAPI('filteredinvoice', invoice, 'POST', true);
    loadData();
});

async function loadData() {
    data = await fetchAPI('filteredinvoices', null, 'GET');
    createTable();
}

function processFilterBy(filterBy) {
    switch(filterBy) {
        case 'none': return 'brak';
        case 'year': return 'rocznik';
        case 'price': return 'cena';
    }
}

function createTable() {
    let html = `<table class="invoicesTable"><thead><tr>
        <th>Nazwa</th>
        <th>Filtrowanie</th>
        <th>Zakres</th>
        <th></th>
    </tr></thead><tbody>`;

    for (let i = 0; i < data.length; i++) {
        let invoice = data[i];
        let rangeText = `${invoice.info.rangeFrom} - ${invoice.info.rangeTo}`;
        if(invoice.info.filterBy == 'none') rangeText = '-'
        html += `<tr>
            <td>${invoice.name}</td>
            <td>${processFilterBy(invoice.info.filterBy)}</td>
            <td>${rangeText}</td>
            <td>
                <div class="actionsCell">
                    <button onclick="downloadInvoice('vat-${invoice.uuid}')">Pobierz fakturę</button>
                </div>
            </td>
        </tr>`;
    }

    html += '</tbody></table>';
    contentDiv.innerHTML = html;
}

loadData();